/*
 * Copyright [2022] [https://www.xiaonuo.vip]
 *
 * Snowy采用APACHE LICENSE 2.0开源协议，您在使用过程中，需要注意以下几点：
 *
 * 1.请不要删除和修改根目录下的LICENSE文件。
 * 2.请不要删除和修改Snowy源码头部的版权声明。
 * 3.本项目代码可免费商业使用，商业使用请保留源码和相关描述文件的项目出处，作者声明等。
 * 4.分发源码时候，请注明软件出处 https://www.xiaonuo.vip
 * 5.不可二次分发开源参与同类竞品，如有想法可联系团队xiaonuobase@qq.com商议合作。
 * 6.若您的项目无法满足以上几点，需要更多功能代码，获取Snowy商业授权许可，请在官网购买授权，地址为 https://www.xiaonuo.vip
 */
package com.unis.basic.info.modular.remindcycle.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollStreamUtil;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.unis.basic.info.modular.remindcycle.entity.RemindCycle;
import com.unis.basic.info.modular.remindcycle.mapper.RemindCycleMapper;
import com.unis.basic.info.modular.remindcycle.param.RemindCycleAddParam;
import com.unis.basic.info.modular.remindcycle.param.RemindCycleEditParam;
import com.unis.basic.info.modular.remindcycle.param.RemindCycleIdParam;
import com.unis.basic.info.modular.remindcycle.param.RemindCyclePageParam;
import com.unis.basic.info.modular.remindcycle.service.RemindCycleService;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import com.unis.common.enums.CommonSortOrderEnum;
import com.unis.common.exception.CommonException;
import com.unis.common.page.CommonPageRequest;
import com.unis.basic.info.modular.remindcycle.entity.RemindCycle;
import com.unis.basic.info.modular.remindcycle.mapper.RemindCycleMapper;
import com.unis.basic.info.modular.remindcycle.param.RemindCycleAddParam;
import com.unis.basic.info.modular.remindcycle.param.RemindCycleEditParam;
import com.unis.basic.info.modular.remindcycle.param.RemindCycleIdParam;
import com.unis.basic.info.modular.remindcycle.param.RemindCyclePageParam;
import com.unis.basic.info.modular.remindcycle.service.RemindCycleService;

import java.util.List;

/**
 * 报送周期Service接口实现类
 *
 * @author weiyinbin
 * @date  2024/04/02 14:45
 **/
@Service
public class RemindCycleServiceImpl extends ServiceImpl<RemindCycleMapper, RemindCycle> implements RemindCycleService {

    @Override
    public Page<RemindCycle> page(RemindCyclePageParam remindCyclePageParam) {
        QueryWrapper<RemindCycle> queryWrapper = new QueryWrapper<>();
        if(ObjectUtil.isAllNotEmpty(remindCyclePageParam.getSortField(), remindCyclePageParam.getSortOrder())) {
            CommonSortOrderEnum.validate(remindCyclePageParam.getSortOrder());
            queryWrapper.orderBy(true, remindCyclePageParam.getSortOrder().equals(CommonSortOrderEnum.ASC.getValue()),
                    StrUtil.toUnderlineCase(remindCyclePageParam.getSortField()));
        } else {
            queryWrapper.lambda().orderByAsc(RemindCycle::getId);
        }
        return this.page(CommonPageRequest.defaultPage(), queryWrapper);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void add(RemindCycleAddParam remindCycleAddParam) {
        RemindCycle remindCycle = BeanUtil.toBean(remindCycleAddParam, RemindCycle.class);
        this.save(remindCycle);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void edit(RemindCycleEditParam remindCycleEditParam) {
        RemindCycle remindCycle = this.queryEntity(remindCycleEditParam.getId());
        BeanUtil.copyProperties(remindCycleEditParam, remindCycle);
        this.updateById(remindCycle);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void delete(List<RemindCycleIdParam> remindCycleIdParamList) {
        // 执行删除
        this.removeByIds(CollStreamUtil.toList(remindCycleIdParamList, RemindCycleIdParam::getId));
    }

    @Override
    public RemindCycle detail(RemindCycleIdParam remindCycleIdParam) {
        return this.queryEntity(remindCycleIdParam.getId());
    }

    @Override
    public RemindCycle queryEntity(String id) {
        RemindCycle remindCycle = this.getById(id);
        if(ObjectUtil.isEmpty(remindCycle)) {
            throw new CommonException("报送周期不存在，id值为：{}", id);
        }
        return remindCycle;
    }
}
